/**
 Trivial pthreads program.
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

/* Describes a range of numbers to count */
struct number_range {
	int lo, hi;
};

int total_count=0;
pthread_mutex_t countLock=PTHREAD_MUTEX_INITIALIZER; // Protects count variable

/**
  *Both* threads call this 
*/
int count_range(number_range *n) {
	for (int i=n->lo;i<n->hi;i++) 
		if ((i%2)==0) {
			pthread_mutex_lock(&countLock);
			total_count++; /* i is even-- add it to the count */
			pthread_mutex_unlock(&countLock);
		}
}

void *count_thread(void *ptr) {
	number_range *n=(number_range *)ptr;
	count_range(n);
}

int main() {
	number_range An;
	number_range Bn;
	An.lo=0;
	An.hi=Bn.lo=5000000;
	Bn.hi=10000000;
	
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_t A;
	pthread_create(&A,&attr,count_thread,&An);
	count_range(&Bn);
	pthread_join(A,0);
	printf("Total count: %d\n",total_count);
	return 0;
}
